//********************************************************************
//*** ResourcePool/SQL/Bind.cc
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: Bind.cc,v 1.6 2005/01/06 16:27:56 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "Bind.hh"

namespace fatalmind {
namespace SQL {

template<class VBC, template<class> class CT>
template<typename T>
void Bind<VBC, CT>::bind(const int pos, const T& val, bool nul) {
	gc_ptr<VBC> ptr(new CT<T>(val));
	ptr->setnull(nul);
	_args.resize(std::max<int>(pos + 1, _args.size()));
	_args[pos] = ptr;
}

template<class VBC, template<class> class CT>
void Bind<VBC, CT>::instantiations() {
	bind<short int>(0, 0);
	bind<int>(0, 0);
	bind<long int>(0, 0);

	bind<unsigned short int>(0, 0);
	bind<unsigned int>(0, 0);
	bind<unsigned long int>(0, 0);

	bind<float>(0, 0);
	bind<double>(0, 0);
	bind<std::string>(0, "");
}

}
}
