//********************************************************************
//*** ResourcePool/SQL/BindOut.hh
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: BindOut.hh,v 1.7 2005/03/13 14:57:15 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_SQL_BINDOUT_HH
#define RESOURCEPOOL_SQL_BINDOUT_HH

#include "ResourcePool/SQL/BindOutInterface.hh"

#ifndef INCLUDED_GC_PTR_HH
#include "mm/gc_ptr.hh"
#endif

#include <vector>

namespace fatalmind {
namespace SQL {

/**
 * This class defines the common interface for all SQL* classes
 * which do return output colums.
 */
template<class VBC, template <class> class CT>
class BindOut: public BindOutInterface {
	public:
		virtual ~BindOut() {
		}

		template<typename T>
		void bindout(const unsigned int pos, T& val);

		bool isnull(const unsigned int pos) const;

	protected:
		VBC& getOutParam(const unsigned int pos);

		typedef std::vector<gc_ptr<VBC> > _outparamt;
		_outparamt _outparam;

	private:
		void instantiations();
};

} // namespace SQL
} // namespace fatalmind
#endif
