/********************************************************************
//*** ResourcePool/SQL/RTSQLSelectRow_Impl.hh
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: RTSQLSelectRow_Impl.hh,v 1.3 2005/03/12 18:17:39 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_SQL_RTSQLSELECTROW_IMPL_HH
#define RESOURCEPOOL_SQL_RTSQLSELECTROW_IMPL_HH

#include "ResourcePool/SQL/RTSQLSelectRow.hh"
#include "ResourcePool/SQL/RTSQLExecute_Impl.hh"

namespace fatalmind {
namespace SQL {


/*

template<class TM>
class RTSQLSelectRow_Impl
: public RTSQLExecute_Impl<TM>
{
	public:
		RTSQLSelectRow_Impl() {
		};

		virtual void bindout(const int pos, short& val) = 0;
		virtual void bindout(const int pos, int& val) = 0;
		virtual void bindout(const int pos, long& val) = 0;
//		virtual void bindout(const int pos, long long& val) = 0;
		virtual void bindout(const int pos, float& val) = 0;
		virtual void bindout(const int pos, double& val) = 0;
		virtual void bindout(const int pos, std::string& val) = 0;

		virtual bool isnull(const unsigned int pos) const = 0;
		virtual RTSQLSelectRow_Impl<TM>* clone() const = 0;
};
*/

template<class TM, template<class TM2>class B, class RT, class CW, class RTC>
class RTSQLSelectRow_SpecializedImpl
: public RTSQLExecute_SpecializedImpl<TM, B, RT, CW, RTC> 
{
		typedef RTSQLExecute_SpecializedImpl<TM, B, RT, CW, RTC> super;
		using super::sqlExecute_;
	public:
		RTSQLSelectRow_SpecializedImpl(RTC& rtc, const std::string& sql)
		: super(rtc, sql)
		{
		}

		virtual void bindout(const int pos, short& val) {
			sqlExecute_.bindout(pos, val);
		}

		virtual void bindout(const int pos, int& val) {
			sqlExecute_.bindout(pos, val);
		}

		virtual void bindout(const int pos, long& val) {
			sqlExecute_.bindout(pos, val);
		}

		virtual void bindout(const int pos, float& val) {
			sqlExecute_.bindout(pos, val);
		}

		virtual void bindout(const int pos, double& val) {
			sqlExecute_.bindout(pos, val);
		}

		virtual void bindout(const int pos, std::string& val) {
			sqlExecute_.bindout(pos, val);
		}

		virtual bool isnull(const unsigned int pos) const {
			return sqlExecute_.isnull(pos);
		}

		virtual RTSQLSelectRow_Impl<TM>* clone() const {
			return new RTSQLSelectRow_SpecializedImpl<TM, B, RT, CW, RTC>(*this);
		}
};

} // namespace SQL
} // namespace fatalmind
#endif
