//********************************************************************
//*** Thread/LockFwd.hh
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: LockFwd.hh,v 1.7 2005/01/06 16:28:06 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef INCLUDED_THREAD_LOCKFWD_HH
#define INCLUDED_THREAD_LOCKFWD_HH

#ifndef INCLUDED_THREAD_LOCKSTATISTICSFWD_HH
#include "LockStatisticsFwd.hh"
#endif

namespace fatalmind {
#ifdef HAVE_PTHREAD_MUTEXATTR_SETTYPE
#ifdef HAVE_PTHREAD_MUTEX_RECURSIVE_NP
#define HAVE_RECURSIVE_LOCK
	template<class Statistics = DefaultLockStatistics> class RecursiveLock;
#endif
#endif

	template<class Statistics = DefaultLockStatistics> class FastLock;

	template<class Statistics = DefaultLockStatistics> class NopLock;

	template<class Statistics = DefaultLockStatistics> struct MultiThreadedModel;

	template<class Statistics = DefaultLockStatistics> struct SingleThreadedModel;
	
	// TODO make configureable
	typedef SingleThreadedModel<> DefaultThreadedModel;

}


#endif
